#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import requests
import schedule
import time

# 获取天气
def get_weather(lat, lon, api_key):
    #每日天气预报
    weather_api_url = f"https://devapi.qweather.com/v7/weather/3d?location={lat},{lon}&key={api_key}"
    response = requests.get(weather_api_url)

    #实时天气https://dev.qweather.com/docs/api/weather/weather-now/
    weather_api_url1 = f"https://devapi.qweather.com/v7/weather/now?location={lat},{lon}&key={api_key}"
    response1 = requests.get(weather_api_url1)

    if response.status_code == 200:
        weather_data = response.json().get("daily", [])[0]
        weather_data1 = response1.json().get("now")
        
        merged_data = {}
        merged_data.update(weather_data)
        merged_data.update(weather_data1)

        print(merged_data)

        return merged_data
    else:
        print(f"Failed to fetch weather data. Status Code: {response.status_code}")
        return None

# 发送消息curl -L -X GET --compressed https://api.qweather.com/v7/weather/3d?location=101010100&key=qwertytqtx
def send_message(content):
    url = "https://qyapi.weixin.qq.com/cgi-bin/webhook/send?key=3acd5b11-98f3-4911-b4eb-bd9090e83635"
    
    headers = {
        "Content-Type": "application/json"
    }

    data = {
        "msgtype": "text",
        "text": {
            "content": content
        }
    }

    response = requests.post(url, json=data, headers=headers)
    print(response.status_code, response.text)

# 获取并发送天气消息
def send_weather_message():
    print("获取并发送天气消息")
    # 替换为你的经度、纬度和和风天气 API Key
    your_api_key = "f241d139d5cf40aba5ee02035974d93e"
    lat = "106.51"
    lon = "29.55"

    # 获取当前真实天气
    weather_data = get_weather(lat, lon, your_api_key)

    if weather_data:
        # 提取天气信息
        tempMin = weather_data["tempMin"]
        tempMax = weather_data["tempMax"]
        textDay = weather_data["textDay"]
        temp = weather_data["temp"]
        rain = weather_data["precip"];
        weather_message = f"重庆今日天气：{temp}，{tempMin}~{tempMax}度，大部分{textDay}，降雨概率：{rain}%"

        # 发送天气消息
        send_message(weather_message)

def send_ad_message():
    send_message("👶🏻宝宝喝AD哦，健健康康开开心心也！")

def send_ahj_message():
    send_message("🤗宝贝喝安合剂哦，爱你哦么么哒！")

def send_ahj1_message():
    send_message("🤗宝贝喝安合剂哦，爱你哦么么哒！")

def send_gp_message():
    send_message("🤗宝贝喝钙片哦，身体棒棒的嘻嘻！")

def send_drink_water_message():
    drink_water_message = "🤗宝贝记得喝水哦，保持身体健康！"
    send_message(drink_water_message)

#测试获取天气
send_weather_message()

# 定义定时任务
schedule.every().day.at("08:10").do(send_weather_message)
schedule.every().day.at("10:00").do(send_ad_message)
schedule.every().day.at("13:10").do(send_ahj_message)
schedule.every().day.at("20:00").do(send_ahj1_message)
schedule.every().day.at("21:00").do(send_gp_message)

# 每隔多久发消息
schedule.every().hour.do(send_drink_water_message)

# 保持脚本运行
while True:
    schedule.run_pending()
    time.sleep(1)
